#include <vector>
#include <iostream>
using std::cout;
using std::endl;
using std::vector;

template <class T>
void print_vec( vector<T>& v )
{
   print_vec( v, 0 );
}

//  Prints the vector in reverse order, just by having changed the
//  order of the recursive call and the cout statement.

template <class T>
void print_vec( vector<T>& v, unsigned int i )
{
  if ( i < v.size() ) 
    {
      print_vec( v, i+1 );
      cout << i << ": " << v[i] << endl;
    }
}

int main()
{ 
  vector<int> a;
  a.push_back( 3 );  a.push_back( 5 );  a.push_back( 11 );
  a.push_back( 17 );
  print_vec( a );
}
