
#include <iostream>
#include <vector>
using namespace std;


//  Here is the non-recursive of binary search.

bool binsearch( const vector<double>& v, double x )
{
  int low = 0;
  int high = v.size()-1;

  while ( low < high )
    {
      int mid = (low+high)/2;

      if ( x <= v[mid] )
	high = mid;
      else
	low = mid+1;
    }

  return x == v[low];
}


int main()
{
  vector<double> a;
  a.push_back( 1.0 );
  a.push_back( 1.25 );
  a.push_back( 2.8 );
  a.push_back( 4.0 );
  a.push_back( 5.4 );
  a.push_back( 7.1 );

  cout << "Looking for -1: " << binsearch( a, -1 ) << endl
       << "Looking for 1: " << binsearch( a, 1.0 ) << endl
       << "Looking for 1.1: " << binsearch( a, 1.1 ) << endl
       << "Looking for 1.25: " << binsearch( a, 1.25 ) << endl
       << "Looking for 7.1: " << binsearch( a, 7.1 ) << endl
       << "Looking for 7.4: " << binsearch( a, 7.4 ) << endl;
  return 0;
}
    
